/*
 * $Id: setenv.java,v 1.1 2004/12/23 12:15:53 rampil Exp $
 * Copyright (c) 2004 LOGICAL-PARADOX.ORG
 */
package org.logical_paradox.gdrn.shell.command;

import java.io.OutputStream;
import java.io.PrintWriter;

import org.logical_paradox.shell.Argument;
import org.logical_paradox.shell.Command;
import org.logical_paradox.shell.ResultCode;
import org.logical_paradox.shell.ShellEnv;
import org.logical_paradox.shell.exception.CommandExecutionException;
import org.logical_paradox.shell.exception.TerminationException;

/**
 * <pre>
 * setenv
 * 
 * ydlz
 * ϐݒ肵܂B
 * 
 * yz
 * setenv <ϐ>=<l>
 * </pre>
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.1 $
 */
public class setenv implements Command {
	public static final String USAGE = "setenv <variable-name>=<value>";

	/**
	 * o͂
	 * @param ostream o͐̃Xg[
	 */
	protected void printHelp(OutputStream ostream) {
		PrintWriter pw = new PrintWriter(ostream);
		pw.println("usage: setenv <variable name>=<value>");
		pw.flush();
		pw.close();
	}
	public ResultCode execute(OutputStream arg0, ShellEnv arg1, Argument arg2) throws CommandExecutionException, TerminationException {
		if(
			arg2 == null ||
			arg2.getArguments().length != 1 ||
			arg2.getArguments()[0].indexOf('=') <= 0 ||
			arg2.getArguments()[0].lastIndexOf('=') == arg2.getArguments()[0].length()-1
		) {
			// Ȃꍇ͏o͂
			printHelp(arg0);
			return new ResultCode(ResultCode.STATUS_ERROR);
		}

		// ϐݒ肷
		String statement = arg2.getArguments()[0];
		int equalPosition = statement.indexOf('=');

		String varname = statement.substring(0, equalPosition);
		String value = statement.substring(equalPosition+1);

		// ϐ̐ݒ
		arg1.setProperty(varname, value);
		return new ResultCode(ResultCode.STATUS_OK);
	}
	public String usage() {
		return USAGE;
	}
}
