/**
 * LOGICAL-PARADOX.ORG variable record manager library
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 * Release 1.0
 * Ep[W
 */
package org.logical_paradox.common.vrm;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import org.logical_paradox.common.io.ByteStream;

/**
 * ϒTCỸR[h
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version 1.0
 */
public abstract class Record implements ByteStream, Comparable {
	protected ByteStream o;

	/**
	 * ftHgRXgN^
	 *
	 */
	public Record() {
	}
	/**
	 * RXgN^
	 * ̃oCg񂩂炱̃R[h𕜌
	 * @param bstream oCg
	 */
	public Record(byte[] bstream) {
		byteStreamToObject(bstream);
	}
	/**
	 * RXgN^
	 * oCgXg[\\ȃIuWFNgɂƂ^Cv
	 * @param stream lIuWFNg
	 */
	public Record(ByteStream stream) {
		o = stream;
	}
	/**
	 * lIuWFNgZbg
	 * @param b lIuWFNg
	 */
	public void setObject(ByteStream b) {
		o = b;
	}
	/**
	 * lIuWFNgԂ
	 * @return lIuWFNg
	 */
	public Object getObject() {
		return o;
	}
	/**
	 * lIuWFNg̃oCg\Ԃ
	 * @return oCg
	 */
	public byte[] getObjectByteStream() {
		return o.byteStream();
	}
	/**
	 * ̃R[h̃TCYԂ
	 * @return oCgTCY
	 */
	public int size() {
		return byteStream().length;
	}
	/**
	 * ̃R[h̃oCg\Ԃ
	 * @return oCg
	 */
	public byte[] byteStream() {
		byte[] bstream = o.byteStream();
		ByteBuffer buffer = ByteBuffer.allocate(4 + bstream.length).order(ByteOrder.BIG_ENDIAN);

		buffer.putInt(bstream.length);				// f[^TCY(4oCg)
		buffer.put(bstream);						// i[f[^̃oCg(ϒ)
		
		return buffer.array();
	}
	/**
	 * oCg񂩂烌R[h𕜌
	 * @param bstream oCg
	 * @throws IllegalArgumentException ̃oCg񂪂
	 */
	protected void byteStreamToObject(byte[] bstream) throws IllegalArgumentException {
		ByteBuffer buffer = ByteBuffer.allocate(bstream.length).order(ByteOrder.BIG_ENDIAN);
		buffer.put(bstream);
		buffer.rewind();
		try {
			byte[] object = new byte[bstream.length];
			buffer.get(object);
			createObjectFromByteStream(object);
		} catch(Exception e) {
			e.printStackTrace();
			throw new IllegalArgumentException(e.getMessage());
		}
	}
	/**
	 * R[hԂ̔r
	 * @param o rΏۃR[h
	 * @return 1:this>o 0:this==o -1:this<o
	 */
	public int compareTo(Object o) {
		Record r = (Record)o;
		if(size() < r.size()) {
			return -1;
		} else if(size() > r.size()) {
			return 1;
		} else {
			return 0;
		}
	}
	public abstract int getRecordSize();
	/**
	 * R[hlr
	 * @param o rΏ
	 * @return true: / false:Ⴄ
	 */
	public abstract boolean equals(Object o);

	/**
	 * oCg񂩂lIuWFNg𕜌
	 * ̃\bh́ChNXŎ
	 * @param bstream oCg
	 * @throws IllegalArgumentException oCg񂩂̒lIuWFNg̕Ɏs
	 */
	protected abstract void createObjectFromByteStream(byte[] bstream) throws IllegalArgumentException;
}
