/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DataRestoreCommand.java,v 1.3 2005/09/17 17:35:49 rampil Exp $
 */
package org.logical_paradox.vsan.dac.command.handler;

import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.logical_paradox.common.io.ExpandableBuffer;
import org.logical_paradox.common.session.IllegalSessionStateException;
import org.logical_paradox.common.session.Session;
import org.logical_paradox.common.util.ByteStreamConverter;
import org.logical_paradox.vsan.dac.DacConstant;
import org.logical_paradox.vsan.dac.NodeContext;
import org.logical_paradox.vsan.dac.Response;
import org.logical_paradox.vsan.dac.ResponseCode;
import org.logical_paradox.vsan.dac.command.exception.CommandExecutionException;
import org.logical_paradox.vsan.dac.command.exception.SessionTerminationException;
import org.logical_paradox.vsan.node.Database;
import org.logical_paradox.vsan.node.DatabaseAccessException;
import org.logical_paradox.vsan.node.dbr.DbRecord;

/**
 * f[^XgAR}h
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.3 $
 */
public class DataRestoreCommand implements DacCommand {
	/** K[ */
	private static final Log log = LogFactory.getLog(DataRestoreCommand.class);

	/**
	 * R}hs
	 * @param session sZbV
	 * @return XVꂽZbV
	 * @throws CommandExecutionException R}hsɔO
	 * @throws SessionTerminationException ڑIɔO
	 */
	public Session execute(Session session) throws CommandExecutionException, SessionTerminationException, DatabaseAccessException {
		try {
			NodeContext ctx = (NodeContext)session.getAttribute(DacConstant.SKEY_NODE_CONTEXT);
			Database db = ctx.getDatabase();

			// ̎M
			byte[] bb = new byte[8];

			InputStream in = (InputStream)session.getAttribute(DacConstant.SKEY_SOCKET_INPUT_STREAM);

			// vR[h
			bb[0] = (byte)in.read();
			bb[1] = (byte)in.read();
			bb[2] = (byte)in.read();
			bb[3] = (byte)in.read();

			int retrieveRecords = ByteStreamConverter.getInt(bb);

			if(retrieveRecords <= 0) {
				log.warn("vꂽR[h0ȉł");
				throw new CommandExecutionException();
			}

			// ₢킹郌R[hԍM
			long[] recordno = new long[retrieveRecords];
			for(int i = 0; i < recordno.length; i++) {
				bb[0] = (byte)in.read();
				bb[1] = (byte)in.read();
				bb[2] = (byte)in.read();
				bb[3] = (byte)in.read();
				bb[4] = (byte)in.read();
				bb[5] = (byte)in.read();
				bb[6] = (byte)in.read();
				bb[7] = (byte)in.read();

				recordno[i] = ByteStreamConverter.getLong(bb);
			}

			// hCf[^x[Xɑ΂Ė₢킹
			DbRecord[] records = db.restoreStream(recordno);
			byte[] datastream = createDataStreamFromRecords(records);

			// ߂l̍쐬
			session.setAttribute(DacConstant.SKEY_DAC_RESPONSE, new Response(ResponseCode.OK, datastream));
			return session;
		} catch(IllegalSessionStateException e) {
			// ZbVp\ȏԂłȂꍇCYZbVI
			log.warn("f[^XgAv܂AZbV\ȏԂł͂܂łB");
			log.warn("ZbVj܂B");
			throw new SessionTerminationException(e);
		} catch(IOException e) {
			log.warn("R}hMI/OO܂");
			throw new CommandExecutionException(e);
		}
	}
	/**
	 * f[^x[XR[hoCgɕϊ
	 * @param records f[^x[XR[h
	 * @return ϊꂽoCg
	 */
	protected byte[] createDataStreamFromRecords(DbRecord[] records) throws IOException {
		ExpandableBuffer exb = new ExpandableBuffer();
		// R[h
		exb.write(ByteStreamConverter.convert(records.length));
		// ꂼ̃R[hoCgɕϊēo^
		for(int i = 0; i < records.length; i++) {
			exb.write(records[i].toByteStream());
		}

		return exb.byteStream();
	}
}
