/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DisposeDatabaseCommand.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.dac.command.handler;

import java.io.IOException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.logical_paradox.common.session.IllegalSessionStateException;
import org.logical_paradox.common.session.Session;
import org.logical_paradox.vsan.dac.DacConstant;
import org.logical_paradox.vsan.dac.NodeContext;
import org.logical_paradox.vsan.dac.Response;
import org.logical_paradox.vsan.dac.ResponseCode;
import org.logical_paradox.vsan.dac.command.exception.CommandExecutionException;
import org.logical_paradox.vsan.dac.command.exception.SessionTerminationException;
import org.logical_paradox.vsan.node.Database;

/**
 * hCf[^x[Xt@C폜R}h
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class DisposeDatabaseCommand implements DacCommand {
	/** K[ */
	private static final Log log = LogFactory.getLog(DisposeDatabaseCommand.class);

	/**
	 * R}hs
	 * @param session sZbV
	 * @return XVꂽZbV
	 * @throws CommandExecutionException R}hsɔO
	 * @throws SessionTerminationException ڑIɔO
	 */
	public Session execute(Session session) throws CommandExecutionException, SessionTerminationException {
		try {
			NodeContext ctx = (NodeContext) session.getAttribute(DacConstant.SKEY_NODE_CONTEXT);
			Database db = ctx.getDatabase();

			// hCf[^x[X̔j
			Response r = null;
			try {
				db.dispose();
				r = new Response(ResponseCode.OK, new byte[0]);
			} catch(IOException e) {
				log.warn("hCf[^x[X̍폜Ɏs܂: ", e);
				// hCf[^x[X̍폜Ɏs
				r = new Response(ResponseCode.DATAFILE_WRITE_ERROR, new byte[0]);
			}

			// R}h̖߂li[
			session.setAttribute(DacConstant.SKEY_DAC_RESPONSE, r);
			return session;
		} catch (IllegalSessionStateException e) {
			// ZbVp\ȏԂłȂꍇCYZbVI
			log.warn("hCf[^x[X̔jv܂AZbV\ȏԂł͂܂łB");
			log.warn("ZbVj܂B");
			throw new SessionTerminationException(e);
		}
	}

}
