/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DomainConnection.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.dfs;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.logical_paradox.vsan.dac.DacConnection;
import org.logical_paradox.vsan.dfs.query.DacBestStoreSpaceQueryCommand;
import org.logical_paradox.vsan.dfs.query.DacQueryCommand;
import org.logical_paradox.vsan.dfs.query.DacQueryThread;
import org.logical_paradox.vsan.domain.Domain;
import org.logical_paradox.vsan.domain.exception.DomainAccessException;
import org.logical_paradox.vsan.node.DiskArrayNode;

/**
 * hCɑ΂ăANZX邽߂̐ڑIuWFNg
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class DomainConnection implements Comparable {
	/** K[ */
	private static final Log log = LogFactory.getLog(DomainConnection.class);

	/** hC̐ڑ(true:ڑ / false:ؒf) */
	private boolean connection = false;
	/** ̐ڑLĂNCAgm[hID̃Xg */
	private List sharingClients = new ArrayList();
	/** ڑhC */
	private Domain domain;
	/** ڑς݃m[hXg(DacConnection) */
	private HashMap nodes = new HashMap();

	/**
	 * RXgN^
	 * @param nodeId ̐ڑLm[hID
	 * @param dm ڑhC
	 */
	public DomainConnection(String nodeId, Domain dm) throws DomainAccessException {
		sharingClients.add(nodeId);
		domain = dm;

		// hCڑ
		connect();
	}
	/**
	 * hCXV
	 * hCXVۂ́ADacڑȂǂCɂKv邱Ƃɒӂ
	 * @param dm VhC
	 */
	public void updateDomain(Domain dm) {
		domain = dm;
	}
	/**
	 * ֘AtĂhCԂD
	 * @return hC
	 */
	public Domain getDomain() {
		return domain;
	}
	/**
	 * ڑLԂ
	 * @return ڑL
	 */
	public int getSharedNum() {
		synchronized(sharingClients) {
			return sharingClients.size();
		}
	}
	/**
	 * ڑς݂ǂԂ
	 * @return true:ڑς / false:ؒf
	 */
	public boolean isConnected() {
		return connection;
	}
	/**
	 * ̃hCڑɃNCAgm[h蓖Ă
	 * @param clientNodeId NCAgm[hID
	 */
	public void share(String clientNodeId) {
		sharingClients.add(clientNodeId);
	}
	/**
	 * ̃hCڑNCAgm[hD
	 * @param clientNodeId NCAgm[hID
	 */
	public void unshare(String clientNodeId) {
		sharingClients.remove(clientNodeId);
	}
	/**
	 * w肳ꂽNCAgɑ΂Đڑ蓖ĂĂ邩ǂԂ
	 * @param nodeId m[hID
	 * @return true:蓖čς / false:蓖
	 */
	public boolean contains(String nodeId) {
		return sharingClients.contains(nodeId);
	}
	/**
	 * hCɎQĂSẴm[hɑ΂Đڑ
	 * ڑłȂm[hꍇAُIƂ<br>
	 * @return hCɑ΂ēߓIɃANZX邽߂̃Zc]NIuWFNg
	 * @throws DomainAccessException hCւ̐ڑɎs
	 */
	protected void connect() throws DomainAccessException {
		log.info("hC[" + domain.getDomainName() + "]ɐڑĂ܂");

		boolean succeed = true;

		// hCɎQĂm[hɐڑ
		for(Iterator it = domain.getNodeList().keySet().iterator(); it.hasNext();) {
			String uri = (String)it.next();
			try {
				// m[hƐڑ
				DacConnection con = DacConnection.open(uri);
				nodes.put(uri, con);
			} catch (IOException e) {
				log.error("hC[" + domain.getDomainName() + "]̃m[h[" + uri + "]ɐڑł܂ł:", e);
				succeed = false;
			}
		}

		if(succeed == false) {
			log.error("hĈ̃m[hɐڑłȂ߁Aڑς݂̃m[hƐؒf܂");
			disconnect();
			connection = false;
			throw new DomainAccessException();
		} else {
			log.info("hC[" + domain.getDomainName() + "]ɐڑ܂");
			connection = true;
		}
	}
	/**
	 * hCj
	 * hCɎQĂSẴm[hƂ̐ڑN[Y
	 * G[Ăđs
	 */
	public void disconnect() {
		log.info("hC[" + domain.getDomainName() + "]jĂ܂");
		synchronized(nodes) {
			for(Iterator it = nodes.values().iterator(); it.hasNext();) {
				DacConnection node = (DacConnection)it.next();
				try {
					node.close();
				} catch(IOException e) {
					log.warn("m[h[" + node.getHost() + "]Ƃ̐ڑؒfɃG[܂:", e);
				}
			}

			// ڑς݃m[hNA
			// G[ĐؒfɎsڑɂĂCăNA
			// ʂƂĐڑςȂɂȂƂĂCDACŃ^CAEĝŖȂ
			nodes.clear();
		}
		connection = false;
		log.info("hC[" + domain.getDomainName() + "]j܂");
	}
	/**
	 * wNCAgm[hÃhCڑ痣E
	 * @param clientNodeId NCAgm[gID
	 * @throws DomainAccessException EɎs
	 */
	public void logout(String clientNodeId) throws DomainAccessException {
		synchronized(sharingClients) {
			if(sharingClients.contains(clientNodeId) == false) {
				// ȃNCAgȂ
				throw new DomainAccessException();
			}
			sharingClients.remove(clientNodeId);
		}
	}
	/**
	 * hCڑɑ΂Ďwm[hǉD
	 * ڑ̃NCAg̏ԂȂǂӎāASɃm[hǉ
	 * @param node m[h
	 */
	public void join(String node) {
		try {
			if(nodes.get(node) != null) {
				log.warn("m[h[" + node + "]Ƃ̐ڑ͊ɊmĂ܂̂ŁA܂");
				return;
			}
			DacConnection con = DacConnection.open(node);
			synchronized(this) {
				nodes.put(node, con);
			}
			log.error("m[h[" + node + "]Ƃ̐ڑm܂B");
		} catch (IOException e) {
			log.error("m[h[" + node + "]Ƃ̐ڑmɎs܂B̃m[h͖܂B", e);
		}

	}
	/**
	 * hCڑwm[h𗣒ED
	 * ڑ̃NCAg̏ԂȂǂӎāASɃm[h؂藣
	 * @param node m[h
	 */
	public void leave(String node) {
		synchronized(nodes) {
			DacConnection target = null;

			for(Iterator it = nodes.values().iterator(); it.hasNext();) {
				DacConnection con = (DacConnection)it.next();
				if(con.getHost().equals(node)) {
					// ̃IuWFNgj
					target = con;
				}
			}

			if(target != null) {
				nodes.remove(target);
				try {
					target.close();
				} catch (IOException e) {
					log.error("m[h[" + node  + "]̗EɎs܂");
				}
			}
		}

	}
	/**
	 * hCɊ蓖ĂĂt@CTCYԂ
	 * @return t@CTCY
	 * @throws DomainAccessException t@CTCY擾ɎsꍇɔO
	 */
	public long size() throws DomainAccessException {
		long size = 0;
		for(Iterator it = domain.getNodeList().values().iterator(); it.hasNext();) {
			DiskArrayNode node = (DiskArrayNode)it.next();
			size += node.getSize();
		}

		return size;
	}
	/**
	 * ʒuf[^
	 * @param recordBegin ݊Jnʒu
	 * @param bstream ރf[^
	 * @throws DomainAccessException ݂Ɏs
	 */
	public void write(long recordBegin, byte[] bstream) throws DomainAccessException {
		DiskArrayNode node = select(recordBegin);
		if(node == null) {
			throw new DomainAccessException();
		}

		// ڑIuWFNg̑I
		DacConnection con = (DacConnection)nodes.get(node.getHost());
		if(con == null) {
			throw new DomainAccessException();
		}

		// 
		con.write(recordBegin, bstream);
	}
	/**
	 * ʒuf[^ǂݍށD
	 * w肳ꂽR[hԍJnʒuƂāAR[hPʂœǂݍށD
	 * @param recordBegin ǂݍ݊Jnʒu
	 * @param bstream ǂݍ񂾃f[^i[obt@
	 * @return ǂݍ񂾃f[^
	 */
	public int read(long recordBegin, byte[] bstream) throws DomainAccessException {
		DiskArrayNode node = select(recordBegin);
		if(node == null) {
			throw new DomainAccessException();
		}

		// ڑIuWFNg̑I
		DacConnection con = (DacConnection)nodes.get(node.getHost());
		if(con == null) {
			throw new DomainAccessException();
		}

		// ǂݍ
		int records = bstream.length / domain.getRecordSize();
		if(bstream.length % domain.getRecordSize() > 0) {
			records++;
		}
		int readRecords = con.read(recordBegin, records, bstream);

		return readRecords;
	}
	/**
	 * w背R[hێm[hIB
	 * @param recordBegin JnR[hԍ
	 * @return m[h(null:Ȃ)
	 */
	protected DiskArrayNode select(long recordBegin) {
		for(Iterator it = domain.getNodeList().values().iterator(); it.hasNext();) {
			DiskArrayNode node = (DiskArrayNode)it.next();
			if(node.contains(recordBegin) == true) {
				return node;
			}
		}
		return null;
	}
	/**
	 * ڑLŔr(\[gp)
	 * @param o rΏ
	 * @return this  o: -1 / this  o : 1 / this == o : 0
	 */
	public int compareTo(Object o) {
		DomainConnection dest = (DomainConnection)o;

		if(dest.getSharedNum() == getSharedNum()) {
			return 0;
		}

		return getSharedNum() < dest.getSharedNum() ? -1 : 1;
	}
	/**
	 * ނ̂ɍœKȈʒuvZD
	 * ݂f[^Aď߂ʒuD<br>
	 * {Iɂ͈ȉ̃ASYƂȂF
	 * <ol>
	 * <li>eDACɑ΂āAœKXgÄ₢킹</li>
	 * <li>₢킹ʂW񂵁AłR[hԍ̏̂œKR[hԍƂ</li>
	 * </ol>
	 * @param size ݂f[^oCg
	 * @return œKV[N|C^(-1:󂫗̈悪݂Ȃ)
	 */
	public long computeBestSeekPointer(int size) {
		long lastRecord = -1L;

		// ₢킹Xbh
		DacQueryThread[] threads = new DacQueryThread[domain.getNodeList().size()];

		int cnt = 0;
		for(Iterator it = domain.getNodeList().values().iterator(); it.hasNext(); cnt++) {
			DiskArrayNode node = (DiskArrayNode)it.next();
			DacConnection con = (DacConnection)nodes.get(node.getHost());
			DacQueryCommand command = new DacBestStoreSpaceQueryCommand(con, size);
			threads[cnt] = new DacQueryThread(command);

			threads[cnt].start();
		}

		// 񏈗ł̖₢킹Jn
		for(int i = 0; i < threads.length; i++) {
			try {
				threads[i].join();
			} catch(InterruptedException e) {
				// XbhI҂킹ɔ荞
				// sȂ炻͂łǂł̂ŁĈ܂ܖ
			}
		}

		// ʂ̎܂Ƃ
		for(int i = 0; i < threads.length; i++) {
			if(threads[i].getCausedException() == null) {
				Long found = (Long)threads[i].getResult();
				if(found != null && lastRecord > found.longValue()) {
					lastRecord = found.longValue();
				}
			} else {
				log.warn("œKXgÄ挟ɗO܂BƂẮAYDACXLbv܂F", threads[i].getCausedException());
			}
		}

		// ꂽR[hԍV[N|C^ɕϊĕԂ
		if(lastRecord < 0) {
			return -1;
		} else {
			return lastRecord * domain.getRecordSize();
		}
	}
}
