/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DomainControllerImpl.java,v 1.4 2005/09/28 16:14:44 rampil Exp $
 */
package org.logical_paradox.vsan.domain;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.HashMap;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.logical_paradox.vsan.node.DiskArrayNode;

/**
 * hCRg[[̎
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.4 $
 */
public class DomainControllerImpl extends UnicastRemoteObject implements DomainController {
	/** K[ */
	private static final Log log = LogFactory.getLog(DomainControllerImpl.class);
	/** hC̃}bv */
	private final HashMap domains = new HashMap();
	/** hCRg[[̎ʖ */
	private final String name;

	/**
	 * RXgN^
	 * @param nodeId ʖ
	 * @throws RemoteException CX^X̐Ɏs
	 */
	public DomainControllerImpl(String nodeId) throws RemoteException {
		name = nodeId;
	}
	/**
	 * hCRg[[̎ʖԂ
	 * @return
	 */
	public String getName() {
		return name;
	}
	/**
	 * o^ĂhCԂD
	 * @return hC
	 * @throws RemoteException ̎擾Ɏs
	 */
	public String[] getDomainNames() throws RemoteException {
		synchronized(domains) {
			String[] dn = (String[])domains.keySet().toArray(new String[0]);
			return dn;
		}
	}
	/**
	 * hC擾
	 * @param name hC
	 * @return hC
	 * @throws RemoteException ̎擾Ɏs
	 */
	public Domain getDomain(String name) throws RemoteException {
		Domain domain = (Domain)domains.get(name);
		if(domain == null) {
			throw new RemoteException();
		}

		return domain;
	}
	/**
	 * whCɃm[hǉD
	 * ǉ悤Ƃm[hɂꍇCm[hXVD
	 * @param domainname hC
	 * @param node m[h
	 * @throws RemoteException ǉɎs
	 */
	public void join(String domainname, DiskArrayNode node) throws RemoteException {
		Domain domain = (Domain)domains.get(domainname);
		if(domain == null) {
			domain = new Domain(domainname, new DiskArrayNode[]{});
		}

		// hCɑ΂ăm[hǉ
		if(domain.getRecordSize() >= 0 && node.getRecordSize() > 0 && domain.getRecordSize() != node.getRecordSize()) {
			log.error("R[hTCYقȂ邽߁AhCDACǉ邱Ƃł܂łB");
			throw new RemoteException();
		}

		// ɂm[hU폜Ăǉ(=u)
		domain.remove(node.getHost());
		domain.add(node);

		domains.put(domainname, domain);

		log.info("hC[" + domainname + "]ɁAm[h[" + node.getHost() + "]ǉ܂");
	}
	/**
	 * whC痣E
	 * @param host m[h̃zXgAhX
	 * @param node m[h
	 * @throws RemoteException EɎs
	 */
	public void leave(String domainname, String host) throws RemoteException {
		Domain domain = (Domain)domains.get(domainname);
		if(domain == null) {
			// hĈ݂Ȃ̂Ŗ
			return;
		}
		domain.remove(host);
		if(domain.isEmpty() == false) {
			domains.put(domainname, domain);
		} else {
			// 1m[hȂȂĂ܂ꍇChC폜
			domains.remove(domainname);
		}

		log.info("hC[" + domainname + "]Am[h[" + host + "]폜܂");
	}

	/**
	 * hCRg[[̃u[gXgbv
	 * @param args vO
	 * @throws Exception ȂO
	 */
	public static final void main(String[] args) throws Exception {
		if(args == null || args.length == 0) {
			System.err.println("usage: java DomainControllerImpl <node-id>");
			return;
		}

		// hCRg[[Jn
		DomainControllerImpl dci = new DomainControllerImpl(args[0]);
		Naming.rebind(dci.getName(), dci);

		log.info("hCRg[[[" +  dci.getName() + "]Jn܂B");
	}
}
