/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DataStreamIoApi.java,v 1.2 2005/09/07 13:38:07 rampil Exp $
 */
package org.logical_paradox.vsan.node.api;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.logical_paradox.common.util.StringUtils;
import org.logical_paradox.vsan.dac.DacProperty;
import org.logical_paradox.vsan.dac.ResponseCode;
import org.logical_paradox.vsan.node.AbstractApi;
import org.logical_paradox.vsan.node.Database;
import org.logical_paradox.vsan.node.DatabaseAccessException;
import org.logical_paradox.vsan.node.dbr.DbFile;
import org.logical_paradox.vsan.node.dbr.DbRecord;

/**
 * Xg[o͊֘AAPI
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class DataStreamIoApi extends AbstractApi {
	/** K[ */
	private static final Log log = LogFactory.getLog(DataStreamIoApi.class);

	/**
	 * RXgN^
	 * @param db f[^x[X
	 */
	public DataStreamIoApi(Database db) {
		super(db);
	}
	/**
	 * w肳ꂽR[hԍ擪ɁA̓Xg[f[^擾ăf[^t@C֏
	 * @param recordBegin JnR[hԍ
	 * @param in f[^\[X̓Xg[
	 * @param size f[^TCY
	 * @return ݂R[hԍ
	 * @throws DatabaseAccessException p[^̕sȂǂŏ𑱍słȂ
	 * @throws IOException NCAgƂ̒ʐMɏQ
	 */
	public long storeStream(long recordBegin, InputStream in, int size) throws DatabaseAccessException, IOException {
		List dbfiles = getSortedDatafiles();

		// R[h쐬p̃obt@
		byte[] recordBuffer = new byte[getDatabase().getRecordSize()];

		// w肳ꂽR[hԍ܂܂Ăf[^t@CT
		int idx = getTargetDbFile(dbfiles, recordBegin);

		if(idx < 0) {
			// w肳ꂽR[hԍ܂ރf[^t@C݂Ȃ
			log.error("R[hԍ[" + recordBegin + "]́ÃhCf[^x[Xɑ݂܂");
			throw new DatabaseAccessException(ResponseCode.NO_RECORD_EXISTS);
		}

		/*
		 * SẴf[^̏o͂܂Ń[v
		 */
		long rno = recordBegin;
		int datasize = 0;
		String writeCacheStr = DacProperty.getProperty("writecache");
		int writeCache = StringUtils.isIntStr(writeCacheStr) ? Integer.parseInt(writeCacheStr) : 1;

		List cache = new ArrayList(writeCache);

		DbFile dbfile = (DbFile)dbfiles.get(idx);
		int writeBytes = 0;

		while(writeBytes < size) {
			// f[^
			recordBuffer[datasize++] = (byte)in.read();
			writeBytes++;

			if(writeBytes % recordBuffer.length == 0) {
				// obt@ςɂȂ̂ŃR[h쐬
				DbRecord record = new DbRecord(rno, recordBuffer.length, recordBuffer, datasize);
				cache.add(record);
				if(cache.size() == writeCache) {
					// LbVȂ̐ݒ肩A邢͏݃LbVςɂȂꍇ͏o
					try {
						dbfile.store(cache);
					} catch (IOException e) {
						log.error("f[^t@Cւ݂̏Ɏs:", e);
						throw new DatabaseAccessException(ResponseCode.DATAFILE_WRITE_ERROR);
					}
				}
				// obt@̏
				recordBuffer = new byte[getDatabase().getRecordSize()];
				datasize = 0;
				rno++;

				// R[hԍύXɂȂ̂ŁAf[^t@CύXɂȂȂ
				DbFile dbf = null;
				for(int i = idx; i < dbfiles.size(); i++) {
					dbf = (DbFile)dbfiles.get(i);
					if(dbf.includes(rno) == true) {
						idx = i;
						// ܂܂ňĂ̂ƈႤf[^t@C̏ꍇA
						// ݂̏݃LbV̓exs̃f[^t@Cɑ΂ďo͂
						dbfile.store(cache);
						cache.clear();

						// ̃f[^t@Cɐ؂ւ
						dbfile = dbf;
						break;
					}
				}
				if(dbfile == null) {
					// ݐ惌R[hĂf[^t@CÃhCf[^x[XɂȂ
					log.error("R[hԍ[" + rno + "]́ÃhCf[^x[Xɑ݂܂");
					throw new DatabaseAccessException(ResponseCode.NO_RECORD_EXISTS);
				}
			}
		}
		if(datasize > 0) {
			// c̃R[ho͂
			DbRecord record = new DbRecord(rno, recordBuffer.length, recordBuffer, datasize);
			// ݑIĂf[^t@Cɑ΂ăR[ho
			cache.add(record);
			dbfile.store(cache);
		}

		// ݂R[hԍԂ
		return rno;
	}
	/**
	 * w肳ꂽR[h𕜌ĕԂ
	 * @param records R[hԍ̔z(Ƀ\[gĂ邱)
	 * @return ꂽR[h
	 */
	public DbRecord[] restoreStream(long[] records) throws DatabaseAccessException, IOException {
		DbRecord[] dbr = new DbRecord[records.length];

		if(records == null || records.length == 0) {
			return new DbRecord[0];
		}

		// ŏ̃R[hԍ܂ރf[^t@CT
		List dbfiles = getSortedDatafiles();
		long recordBegin = records[0];

		int idx = getTargetDbFile(dbfiles, recordBegin);
		if(idx < 0) {
			// w肳ꂽR[hԍ܂ރf[^t@C݂Ȃ
			log.error("R[hԍ[" + recordBegin + "]́ÃhCf[^x[Xɑ݂܂");
			throw new DatabaseAccessException(ResponseCode.NO_RECORD_EXISTS);
		}

		DbFile dbf = (DbFile)dbfiles.get(idx);

		// w肳ꂽSR[h擾
		int di = 0;
		while(di < dbr.length) {
			long rno = records[di];
			if(dbf.includes(rno) == true) {
				// ݑIĂf[^t@CAړĨR[h܂ޏꍇ
				dbr[di++] = dbf.restore(rno);
			} else {
				// ݑIĂf[^t@CAړĨR[h܂܂Ȃꍇ
				// f[^t@CđI
				idx++;
				if(idx >= dbfiles.size()) {
					// w肳ꂽR[hԍ܂ރf[^t@C݂Ȃ
					log.error("R[hԍ[" + recordBegin + "]́ÃhCf[^x[Xɑ݂܂");
					throw new DatabaseAccessException(ResponseCode.NO_RECORD_EXISTS);
				}
				dbf = (DbFile)dbfiles.get(idx);
			}
		}

		return dbr;
	}
	/**
	 * w肳ꂽR[hԍ܂ރf[^t@CԂ
	 * @param dbfiles f[^x[Xt@C̃Xg(R[hԍɃ\[gς݂̂)
	 * @param recordno R[hԍ
	 * @return dbfiles̃CfbNX(-1:݂Ȃ)
	 */
	protected int getTargetDbFile(List dbfiles, long recordBegin) {
		// w肳ꂽR[hԍ܂܂Ăf[^t@CT
		int idx = 0;
		for(Iterator it = dbfiles.iterator(); it.hasNext(); idx++) {
			DbFile dbf = (DbFile)it.next();
			if(dbf.getRecordBegin() <= recordBegin && dbf.getRecordEnd() >= recordBegin) {
				return idx;
			}
		}
		return -1;
	}
}
