/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: VSanRecordAccessor.java,v 1.1 2005/09/07 13:38:07 rampil Exp $
 */
package org.logical_paradox.vsan.vfi;

import java.io.EOFException;
import java.io.IOException;

import org.logical_paradox.vsan.dfs.DomainConnectionProxy;
import org.logical_paradox.vsan.dfs.DomainDataStream;
import org.logical_paradox.vsan.dfs.DomainFileSystem;
import org.logical_paradox.vsan.lookup.LookupFactory;

/**
 * zSANXg[Wf[^\[XƂ郌R[hANZXC^[tF[X
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.1 $
 */
public class VSanRecordAccessor implements RecordAccessor {
	/** hCڑvLV */
	private DomainConnectionProxy proxy = null;

	/**
	 * RXgN^D
	 */
	public VSanRecordAccessor() {
	}
	/**
	 * w薼̂̃f[^\[XɐڑD
	 * @param name f[^\[X
	 * @throws IOException ڑɎs
	 */
	public void open(String name) throws IOException {
		DomainFileSystem dfs = LookupFactory.getLookup().lookupDomainFileSystem(name);
		proxy = dfs.getConnection("VSANRACLIENT:" + System.currentTimeMillis());
	}
	/**
	 * ݐڑĂf[^\[XƂ̐ڑD
	 * @throws IOException ڑN[YɎs
	 */
	public void close() throws IOException {
		if(proxy != null) {
			proxy.disconnect();
			proxy = null;
		}
	}
	/**
	 * f[^\[XƂ̐ڑN[YĂ邩ǂԂD
	 * @return true:ɃN[YĂ / false:܂ڑĂ
	 */
	public boolean isClosed() {
		return proxy == null;
	}
	/**
	 * w背R[hԍf[^擾D
	 * @param recordBegin JnR[hԍ
	 * @param b 擾f[^i[z(ɓǂݍ݃TCY˂)
	 * @return ۂɓǂݍ܂ꂽf[^TCY
	 * @throws IOException ǂݍݏɔO
	 * @throws EOFException JnR[hf[^\[X̏I[zĂ
	 */
	public int read(long recordBegin, byte[] b) throws IOException, EOFException {
		DomainDataStream ds = proxy.readRecords(recordBegin, b.length);
		if(ds == null) {
			throw new IOException();
		}

		byte[] data = ds.getStream();
		int size = ds.getSize();

		if(size > b.length || data.length > b.length) {
			// 擾łf[^
			throw new EOFException();
		}

		// 擾łf[^Rs[
		System.arraycopy(data, 0, b, 0, size);

		return size;
	}
	/**
	 * w背R[hԍf[^ށD
	 * JnR[hXg[W̊Oɂ邩A邢͎gT|[gĂȂXg[W
	 * Xg[W͈̔͂𒴂ď݂悤ƂꍇAEOFExceptionD
	 * @param recordBegin JnR[hԍ
	 * @param b ރf[^
	 * @throws IOException ݏɔO
	 * @throws EOFException ݔ͈͂Xg[W̃TCYI[o[
	 */
	public void write(long recordBegin, byte[] b) throws IOException, EOFException {
		proxy.writeRecords(recordBegin, b);
	}
}
