/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DomainConnectionProviderTest.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.dfs;

import java.util.ResourceBundle;

import org.logical_paradox.vsan.domain.Domain;
import org.logical_paradox.vsan.domain.exception.DomainAccessException;
import org.logical_paradox.vsan.node.DiskArrayNode;

import junit.framework.TestCase;

/**
 * hCڑvoC_[̃eXg
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class DomainConnectionProviderTest extends TestCase {
	/** eXgp̃RtBO[V */
	private DfsConfig config = null;
	/** eXgp̃hC */
	private Domain domain = null;

	/**
	 * Constructor for DomainConnectionProviderTest.
	 * @param arg0
	 */
	public DomainConnectionProviderTest(String arg0) {
		super(arg0);
	}

	/**
	 * VhCڑmeXg
	 * ҌʁGVڑCX^XԋpB
	 */
	public void testGetNewDomainConnection() throws DomainAccessException {
		DomainConnectionProvider dcp = new DomainConnectionProviderMoc(config, domain);

		assertEquals(0, dcp.size());

		DomainConnection con = dcp.getConnection("node01");
		assertEquals(1, con.getSharedNum());
		assertEquals(1, dcp.size());
	}

	/**
	 * hCڑ̃TCNɊւeXg
	 * ҌʁFCX^XԂ
	 * @throws DomainAccessException
	 */
	public void testRecycleDomainConnection() throws DomainAccessException {
		DomainConnectionProvider dcp = new DomainConnectionProviderMoc(config, domain);

		assertEquals(0, dcp.size());

		// ڑ1
		DomainConnection con1 = dcp.getConnection("node01");
		assertEquals(1, con1.getSharedNum());
		assertEquals(1, dcp.size());

		// ڑ2
		DomainConnection con2 = dcp.getConnection("node02");
		assertEquals(1, con2.getSharedNum());
		assertEquals(2, dcp.size());

		// ڑ3
		DomainConnection con3 = dcp.getConnection("node03");
		assertEquals(2, con3.getSharedNum());
		assertEquals(2, con1.getSharedNum());
		assertEquals(2, dcp.size());

		assertSame(con1, con3);
		assertFalse(con3 == con2);
	}

	/**
	 * hCڑ̌EzeXg
	 * ҌʁFO
	 * @throws DomainConnection
	 */
	public void testOverConnectionLimit() throws DomainAccessException {
		DomainConnectionProvider dcp = new DomainConnectionProviderMoc(config, domain);

		DomainConnection con = null;
		// 10ZbV܂łOK(2ڑ5ZbVŋL)
		for(int i = 0; i < 10; i++) {
			con = dcp.getConnection("node" + i);
		}

		try {
			// 11ZbVڂ̓_
			dcp.getConnection("overflowconnection");
			fail();
		} catch(DomainAccessException e) {
			// OK
		}
	}

	// eXgp̃bN
	class DomainConnectionProviderMoc extends DomainConnectionProvider {
		/**
		 * @param cfg
		 * @param d
		 */
		public DomainConnectionProviderMoc(DfsConfig cfg, Domain d) {
			super(cfg, d);
		}
		// KȃhCڑԂ
		protected DomainConnection newConnection(String clientNodeId)
			throws DomainAccessException {

			return new DomainConnectionMoc(clientNodeId, getDomain());
		}

		public int size() {
			return super.size();
		}

	}
	class DomainConnectionMoc extends DomainConnection {
		/**
		 * @param nodeId
		 * @param dm
		 * @throws DomainAccessException
		 */
		public DomainConnectionMoc(String nodeId, Domain dm) throws DomainAccessException {
			super(nodeId, dm);
		}
		// DACɐڑӂ
		protected void connect() throws DomainAccessException {
		}

	}
	protected void setUp() throws Exception {
		// eXgp̃\[Xǂݍ
		config = new DfsConfig(ResourceBundle.getBundle("dfs_test"));

		// eXgp̃hC쐬
		domain = new Domain("domain01", new DiskArrayNode[]{
			new DiskArrayNode("n001"), new DiskArrayNode("n002"), new DiskArrayNode("n003")
			}
		);
	}

}
